<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: gees.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_571b715927b0d4b7bee37d60dac387ec.html">matrix</a></li><li class="navelem"><a class="el" href="dir_c689ff6412e242924708ae7afde5c3e6.html">lapack</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">gees.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2010  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#ifndef DLIB_LAPACk_ES_Hh_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#define DLIB_LAPACk_ES_Hh_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;fortran_id.h&quot;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;../matrix.h&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160; </div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;{</div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;    <span class="keyword">namespace </span>lapack</div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;    {</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;        <span class="keyword">namespace </span>binding</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;        {</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#if defined(__alpha__) || defined(__sparc64__) || defined(__x86_64__) || defined(__ia64__)</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;            <span class="keyword">typedef</span> <span class="keywordtype">int</span> logical;</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#else</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;            <span class="keyword">typedef</span> <span class="keywordtype">long</span> <span class="keywordtype">int</span> logical;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;            <span class="keyword">typedef</span> logical (*L_fp)(...);</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160; </div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;            <span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;            {</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;                <span class="keywordtype">void</span> DLIB_FORTRAN_ID(dgees) (<span class="keywordtype">char</span> *jobvs, <span class="keywordtype">char</span> *sort, L_fp select, integer *n, </div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;                                             <span class="keywordtype">double</span> *a, integer *lda, integer *sdim, <span class="keywordtype">double</span> *wr, </div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;                                             <span class="keywordtype">double</span> *wi, <span class="keywordtype">double</span> *vs, integer *ldvs, <span class="keywordtype">double</span> *work, </div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;                                             integer *lwork, logical *bwork, integer *info);</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160; </div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;                <span class="keywordtype">void</span> DLIB_FORTRAN_ID(sgees) (<span class="keywordtype">char</span> *jobvs, <span class="keywordtype">char</span> *sort, L_fp select, integer *n, </div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;                                             <span class="keywordtype">float</span> *a, integer *lda, integer *sdim, <span class="keywordtype">float</span> *wr, </div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;                                             <span class="keywordtype">float</span> *wi, <span class="keywordtype">float</span> *vs, integer *ldvs, <span class="keywordtype">float</span> *work, </div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;                                             integer *lwork, logical *bwork, integer *info);</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160; </div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;            }</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160; </div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;            <span class="keyword">inline</span> <span class="keywordtype">int</span> gees (<span class="keywordtype">char</span> jobvs, integer n, </div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;                             <span class="keywordtype">double</span> *a, integer lda, <span class="keywordtype">double</span> *wr, </div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;                             <span class="keywordtype">double</span> *wi, <span class="keywordtype">double</span> *vs, integer ldvs, <span class="keywordtype">double</span> *work, </div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;                             integer lwork)</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;            {</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;                <span class="comment">// No sorting allowed</span></div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;                integer info = 0;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;                <span class="keywordtype">char</span> sort = <span class="charliteral">&#39;N&#39;</span>;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;                L_fp fnil = 0;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;                logical nil = 0;</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;                integer sdim = 0;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;                DLIB_FORTRAN_ID(dgees)(&amp;jobvs, &amp;sort, fnil, &amp;n,</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;                                       a, &amp;lda, &amp;sdim, wr,</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;                                       wi, vs, &amp;ldvs, work,</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;                                       &amp;lwork, &amp;nil, &amp;info);</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;                <span class="keywordflow">return</span> info;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;            }</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160; </div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160; </div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;            <span class="keyword">inline</span> <span class="keywordtype">int</span> gees (<span class="keywordtype">char</span> jobvs, integer n, </div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;                             <span class="keywordtype">float</span> *a, integer lda, <span class="keywordtype">float</span> *wr, </div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;                             <span class="keywordtype">float</span> *wi, <span class="keywordtype">float</span> *vs, integer ldvs, <span class="keywordtype">float</span> *work, </div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;                             integer lwork)</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;            {</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;                <span class="comment">// No sorting allowed</span></div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;                integer info = 0;</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;                <span class="keywordtype">char</span> sort = <span class="charliteral">&#39;N&#39;</span>;</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;                L_fp fnil = 0;</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;                logical nil = 0;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;                integer sdim = 0;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;                DLIB_FORTRAN_ID(sgees)(&amp;jobvs, &amp;sort, fnil, &amp;n,</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;                                       a, &amp;lda, &amp;sdim, wr,</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;                                       wi, vs, &amp;ldvs, work,</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;                                       &amp;lwork, &amp;nil, &amp;info);</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;                <span class="keywordflow">return</span> info;</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;            }</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160; </div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160; </div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;        }</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160; </div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <span class="comment">// ------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160; </div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<span class="comment">/*  -- LAPACK driver routine (version 3.1) -- */</span></div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;<span class="comment">/*     Univ. of Tennessee, Univ. of California Berkeley and NAG Ltd.. */</span></div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;<span class="comment">/*     November 2006 */</span></div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160; </div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;<span class="comment">/*     .. Scalar Arguments .. */</span></div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<span class="comment">/*     .. */</span></div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;<span class="comment">/*     .. Array Arguments .. */</span></div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;<span class="comment">/*     .. */</span></div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;<span class="comment">/*     .. Function Arguments .. */</span></div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;<span class="comment">/*     .. */</span></div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160; </div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;<span class="comment">/*  Purpose */</span></div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;<span class="comment">/*  ======= */</span></div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160; </div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;<span class="comment">/*  DGEES computes for an N-by-N real nonsymmetric matrix A, the */</span></div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;<span class="comment">/*  eigenvalues, the real Schur form T, and, optionally, the matrix of */</span></div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;<span class="comment">/*  Schur vectors Z.  This gives the Schur factorization A = Z*T*(Z**T). */</span></div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160; </div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;<span class="comment">/*  Optionally, it also orders the eigenvalues on the diagonal of the */</span></div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;<span class="comment">/*  real Schur form so that selected eigenvalues are at the top left. */</span></div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;<span class="comment">/*  The leading columns of Z then form an orthonormal basis for the */</span></div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;<span class="comment">/*  invariant subspace corresponding to the selected eigenvalues. */</span></div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160; </div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;<span class="comment">/*  A matrix is in real Schur form if it is upper quasi-triangular with */</span></div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;<span class="comment">/*  1-by-1 and 2-by-2 blocks. 2-by-2 blocks will be standardized in the */</span></div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;<span class="comment">/*  form */</span></div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;<span class="comment">/*          [  a  b  ] */</span></div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;<span class="comment">/*          [  c  a  ] */</span></div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160; </div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;<span class="comment">/*  where b*c &lt; 0. The eigenvalues of such a block are a +- sqrt(bc). */</span></div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160; </div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;<span class="comment">/*  Arguments */</span></div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;<span class="comment">/*  ========= */</span></div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160; </div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;<span class="comment">/*  JOBVS   (input) CHARACTER*1 */</span></div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;<span class="comment">/*          = &#39;N&#39;: Schur vectors are not computed; */</span></div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;<span class="comment">/*          = &#39;V&#39;: Schur vectors are computed. */</span></div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160; </div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;<span class="comment">/*  SORT    (input) CHARACTER*1 */</span></div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;<span class="comment">/*          Specifies whether or not to order the eigenvalues on the */</span></div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;<span class="comment">/*          diagonal of the Schur form. */</span></div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;<span class="comment">/*          = &#39;N&#39;: Eigenvalues are not ordered; */</span></div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;<span class="comment">/*          = &#39;S&#39;: Eigenvalues are ordered (see SELECT). */</span></div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160; </div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;<span class="comment">/*  SELECT  (external procedure) LOGICAL FUNCTION of two DOUBLE PRECISION arguments */</span></div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;<span class="comment">/*          SELECT must be declared EXTERNAL in the calling subroutine. */</span></div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;<span class="comment">/*          If SORT = &#39;S&#39;, SELECT is used to select eigenvalues to sort */</span></div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;<span class="comment">/*          to the top left of the Schur form. */</span></div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;<span class="comment">/*          If SORT = &#39;N&#39;, SELECT is not referenced. */</span></div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;<span class="comment">/*          An eigenvalue WR(j)+sqrt(-1)*WI(j) is selected if */</span></div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;<span class="comment">/*          SELECT(WR(j),WI(j)) is true; i.e., if either one of a complex */</span></div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;<span class="comment">/*          conjugate pair of eigenvalues is selected, then both complex */</span></div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;<span class="comment">/*          eigenvalues are selected. */</span></div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;<span class="comment">/*          Note that a selected complex eigenvalue may no longer */</span></div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;<span class="comment">/*          satisfy SELECT(WR(j),WI(j)) = .TRUE. after ordering, since */</span></div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;<span class="comment">/*          ordering may change the value of complex eigenvalues */</span></div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;<span class="comment">/*          (especially if the eigenvalue is ill-conditioned); in this */</span></div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;<span class="comment">/*          case INFO is set to N+2 (see INFO below). */</span></div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160; </div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;<span class="comment">/*  N       (input) INTEGER */</span></div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;<span class="comment">/*          The order of the matrix A. N &gt;= 0. */</span></div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160; </div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;<span class="comment">/*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N) */</span></div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;<span class="comment">/*          On entry, the N-by-N matrix A. */</span></div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;<span class="comment">/*          On exit, A has been overwritten by its real Schur form T. */</span></div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160; </div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;<span class="comment">/*  LDA     (input) INTEGER */</span></div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;<span class="comment">/*          The leading dimension of the array A.  LDA &gt;= max(1,N). */</span></div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160; </div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;<span class="comment">/*  SDIM    (output) INTEGER */</span></div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;<span class="comment">/*          If SORT = &#39;N&#39;, SDIM = 0. */</span></div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;<span class="comment">/*          If SORT = &#39;S&#39;, SDIM = number of eigenvalues (after sorting) */</span></div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;<span class="comment">/*                         for which SELECT is true. (Complex conjugate */</span></div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;<span class="comment">/*                         pairs for which SELECT is true for either */</span></div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;<span class="comment">/*                         eigenvalue count as 2.) */</span></div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160; </div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;<span class="comment">/*  WR      (output) DOUBLE PRECISION array, dimension (N) */</span></div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;<span class="comment">/*  WI      (output) DOUBLE PRECISION array, dimension (N) */</span></div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;<span class="comment">/*          WR and WI contain the real and imaginary parts, */</span></div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;<span class="comment">/*          respectively, of the computed eigenvalues in the same order */</span></div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;<span class="comment">/*          that they appear on the diagonal of the output Schur form T. */</span></div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;<span class="comment">/*          Complex conjugate pairs of eigenvalues will appear */</span></div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;<span class="comment">/*          consecutively with the eigenvalue having the positive */</span></div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;<span class="comment">/*          imaginary part first. */</span></div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160; </div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;<span class="comment">/*  VS      (output) DOUBLE PRECISION array, dimension (LDVS,N) */</span></div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;<span class="comment">/*          If JOBVS = &#39;V&#39;, VS contains the orthogonal matrix Z of Schur */</span></div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;<span class="comment">/*          vectors. */</span></div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;<span class="comment">/*          If JOBVS = &#39;N&#39;, VS is not referenced. */</span></div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160; </div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;<span class="comment">/*  LDVS    (input) INTEGER */</span></div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;<span class="comment">/*          The leading dimension of the array VS.  LDVS &gt;= 1; if */</span></div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;<span class="comment">/*          JOBVS = &#39;V&#39;, LDVS &gt;= N. */</span></div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160; </div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;<span class="comment">/*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (MAX(1,LWORK)) */</span></div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;<span class="comment">/*          On exit, if INFO = 0, WORK(1) contains the optimal LWORK. */</span></div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160; </div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;<span class="comment">/*  LWORK   (input) INTEGER */</span></div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;<span class="comment">/*          The dimension of the array WORK.  LWORK &gt;= max(1,3*N). */</span></div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;<span class="comment">/*          For good performance, LWORK must generally be larger. */</span></div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160; </div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;<span class="comment">/*          If LWORK = -1, then a workspace query is assumed; the routine */</span></div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;<span class="comment">/*          only calculates the optimal size of the WORK array, returns */</span></div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;<span class="comment">/*          this value as the first entry of the WORK array, and no error */</span></div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;<span class="comment">/*          message related to LWORK is issued by XERBLA. */</span></div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160; </div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;<span class="comment">/*  BWORK   (workspace) LOGICAL array, dimension (N) */</span></div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;<span class="comment">/*          Not referenced if SORT = &#39;N&#39;. */</span></div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160; </div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;<span class="comment">/*  INFO    (output) INTEGER */</span></div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;<span class="comment">/*          = 0: successful exit */</span></div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;<span class="comment">/*          &lt; 0: if INFO = -i, the i-th argument had an illegal value. */</span></div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;<span class="comment">/*          &gt; 0: if INFO = i, and i is */</span></div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;<span class="comment">/*             &lt;= N: the QR algorithm failed to compute all the */</span></div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;<span class="comment">/*                   eigenvalues; elements 1:ILO-1 and i+1:N of WR and WI */</span></div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;<span class="comment">/*                   contain those eigenvalues which have converged; if */</span></div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;<span class="comment">/*                   JOBVS = &#39;V&#39;, VS contains the matrix which reduces A */</span></div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;<span class="comment">/*                   to its partially converged Schur form. */</span></div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;<span class="comment">/*             = N+1: the eigenvalues could not be reordered because some */</span></div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;<span class="comment">/*                   eigenvalues were too close to separate (the problem */</span></div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;<span class="comment">/*                   is very ill-conditioned); */</span></div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;<span class="comment">/*             = N+2: after reordering, roundoff changed values of some */</span></div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;<span class="comment">/*                   complex eigenvalues so that leading eigenvalues in */</span></div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;<span class="comment">/*                   the Schur form no longer satisfy SELECT=.TRUE.  This */</span></div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;<span class="comment">/*                   could also be caused by underflow due to scaling. */</span></div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160; </div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;    <span class="comment">// ------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160; </div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;        <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;            <span class="keyword">typename</span> T, </div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;            <span class="keywordtype">long</span> NR1, <span class="keywordtype">long</span> NR2, <span class="keywordtype">long</span> NR3, <span class="keywordtype">long</span> NR4,</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;            <span class="keywordtype">long</span> NC1, <span class="keywordtype">long</span> NC2, <span class="keywordtype">long</span> NC3, <span class="keywordtype">long</span> NC4,</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;            <span class="keyword">typename</span> MM,</div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;            <span class="keyword">typename</span> layout</div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;            &gt;</div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;        <span class="keywordtype">int</span> gees (</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;            <span class="keyword">const</span> <span class="keywordtype">char</span> jobz,</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;            matrix&lt;T,NR1,NC1,MM,column_major_layout&gt;&amp; a,</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;            matrix&lt;T,NR2,NC2,MM,layout&gt;&amp; wr,</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;            matrix&lt;T,NR3,NC3,MM,layout&gt;&amp; wi,</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;            matrix&lt;T,NR4,NC4,MM,column_major_layout&gt;&amp; vs</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;        )</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;        {</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;            matrix&lt;T,0,1,MM,column_major_layout&gt; work;</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160; </div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;            <span class="keyword">const</span> <span class="keywordtype">long</span> n = a.nr();</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160; </div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;            wr.set_size(n,1);</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;            wi.set_size(n,1);</div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160; </div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;            <span class="keywordflow">if</span> (jobz == <span class="charliteral">&#39;V&#39;</span>)</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;                vs.set_size(n,n);</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;            <span class="keywordflow">else</span></div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;                vs.set_size(NR4?NR4:1, NC4?NC4:1);</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160; </div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;            <span class="comment">// figure out how big the workspace needs to be.</span></div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;            T work_size = 1;</div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;            <span class="keywordtype">int</span> info = binding::gees(jobz, n, </div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;                                     &amp;a(0,0), a.nr(), &amp;wr(0,0), </div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;                                     &amp;wi(0,0), &amp;vs(0,0), vs.nr(), &amp;work_size, </div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;                                     -1);</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160; </div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;            <span class="keywordflow">if</span> (info != 0)</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;                <span class="keywordflow">return</span> info;</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160; </div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;            <span class="keywordflow">if</span> (work.size() &lt; work_size)</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;                work.set_size(static_cast&lt;long&gt;(work_size), 1);</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160; </div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;            <span class="comment">// compute the actual decomposition </span></div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;            info = binding::gees(jobz, n, </div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;                                 &amp;a(0,0), a.nr(), &amp;wr(0,0), </div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;                                 &amp;wi(0,0), &amp;vs(0,0), vs.nr(), &amp;work(0,0), </div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;                                 work.size());</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160; </div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;            <span class="keywordflow">return</span> info;</div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;        }</div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160; </div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;    <span class="comment">// ------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160; </div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;    }</div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160; </div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;}</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160; </div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160; </div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;<span class="preprocessor">#endif // DLIB_LAPACk_ES_Hh_</span></div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
